#ifndef FILESEARCH_H
#define FILESEARCH_H

#include <QObject>

class ResultFile : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString path READ path NOTIFY pathChanged)
    Q_PROPERTY(QString name READ name NOTIFY nameChanged)
    Q_PROPERTY(QString type READ type NOTIFY typeChanged)
    Q_PROPERTY(qint64 size READ size NOTIFY sizeChanged)
    Q_PROPERTY(bool selected READ selected WRITE setSelected NOTIFY selectedChanged)
    QString m_path;
    QString m_name;
    QString m_type;
    qint64 m_size;
    bool m_selected;
public:
    ResultFile(QString path, QString name, QString type, qint64 size):
        m_path(path), m_name(name), m_type(type), m_size(size),
        m_selected(false)
    {}
    QString path(){ return m_path; }
    QString name(){ return m_name; }
    QString type(){ return m_type; }
    qint64 size(){ return m_size; }
    bool selected(){ return m_selected; }
    void setSelected(bool selected){ m_selected = selected; selectedChanged(); }
signals:
    void pathChanged();
    void nameChanged();
    void typeChanged();
    void sizeChanged();
    void selectedChanged();
};

class FileSearch : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QList<QObject*> result READ result NOTIFY resultChanged)
    Q_PROPERTY(QString searchPath READ searchPath WRITE setSearchPath NOTIFY searchPathChanged)
    QList<QObject*> m_result;
    QString m_search_path;
    QString m_search_string;
public:
    explicit FileSearch(QObject *parent = 0);
    QList<QObject*> result(){ return m_result; }
    QString searchPath(){ return m_search_path; }
    void setSearchPath(QString searchPath);
    void search();

    Q_INVOKABLE void search(QString text);

signals:
    void resultChanged();
    void searchPathChanged();

public slots:

};

#endif // FILESEARCH_H
