import QtQuick 2.0
import Sailfish.Silica 1.0
import harbour.metacrane.MetacraneClient 1.0

Dialog {
    property string crane_name: "Unknown"
    property double deletionTime: 1.0

    id: page
    canAccept: textArea.text.length > 0
    allowedOrientations: Orientation.All

    Column {
        spacing: Theme.paddingLarge
        PageHeader {
            title: "Upload Text | "+crane_name
        }
        Slider {
            id: timeSlider
            minimumValue: realToTimeSlider(10*60)
            maximumValue: 1.0
            value: 1.0
            valueText:
                timeSliderToReal(value) < 120*60 ?
                    "" + Math.floor(timeSliderToReal(value) / 60) + " minutes" :
                Math.floor(timeSliderToReal(value) / 3600) + " hours"
            label: "Deletion Time"
            x: Theme.paddingLarge
            width: page.width - Theme.paddingLarge * 2

            onValueChanged: {
                deletionTime = timeSliderToReal(value)
            }
            Component.onCompleted: {
                deletionTime = timeSliderToReal(value)
            }
        }
        TextArea {
            id: textArea
            focus: true
            //anchors.fill: parent
            //anchors.margins: Theme.paddingLarge
            //anchors.centerIn: parent
            x: Theme.paddingLarge
            width: page.width - Theme.paddingLarge * 2
            text: ""
            wrapMode: Text.Wrap
        }
    }

    onAccepted: {
        console.log("Accepted with deletion time "+deletionTime)
        MetacraneClient.uploadText(textArea.text, deletionTime)
    }

    function timeSliderToReal(value){
        return Math.pow(value, 3) * 56*3600
    }
    function realToTimeSlider(seconds){
        return Math.pow(seconds/(56*3600), 1/3)
    }}
