#include "metacranemediatransfer.h"

#define SERVER_SERVICE "harbour.metacrane.client"
#define SERVER_PATH "/"
#define SERVER_INTERFACE "harbour.metacrane.client"

MetacraneMediaTransfer::MetacraneMediaTransfer(QObject *parent) :
    MediaTransferInterface(parent)
{
    m_iface = new QDBusInterface(SERVER_SERVICE, SERVER_PATH, SERVER_INTERFACE, QDBusConnection::sessionBus(), this);

    // TODO
    /*QDBusConnection::sessionBus().connect(SERVER_SERVICE, SERVER_PATH, SERVER_INTERFACE,
                                          "uploadFailed", this, SIGNAL(uploadMediaFailed(QString,QString)));
    QDBusConnection::sessionBus().connect(SERVER_SERVICE, SERVER_PATH, SERVER_INTERFACE,
                                          "uploadFinished", this, SIGNAL(uploadMediaFinished(QString,QString,QString)));
    QDBusConnection::sessionBus().connect(SERVER_SERVICE, SERVER_PATH, SERVER_INTERFACE,
                                          "uploadStarted", this, SIGNAL(uploadMediaStarted(QString,QString,QString)));
    QDBusConnection::sessionBus().connect(SERVER_SERVICE, SERVER_PATH, SERVER_INTERFACE,
                                          "uploadProgress", this, SIGNAL(uploadMediaProgress(QString,QString,int)));*/
}

MetacraneMediaTransfer::~MetacraneMediaTransfer()
{

}

bool MetacraneMediaTransfer::cancelEnabled() const
{
    return false;
}

QString MetacraneMediaTransfer::displayName() const
{
    return QString("Metacrane");
}

bool MetacraneMediaTransfer::restartEnabled() const
{
    return false;
}

QUrl MetacraneMediaTransfer::serviceIcon() const
{
    return QUrl::fromLocalFile("/usr/share/icons/hicolor/86x86/apps/harbour-metacrane.png");
}

void MetacraneMediaTransfer::uploadMediaProgress(const QString &jid, const QString &msgId, int percent)
{
    // TODO: Copied from mitakuuluu2
    Q_UNUSED(jid);
    if (msgId == _messageId) {
        if (percent < 100) {
            qreal s_progress = (qreal)percent / (qreal)100;
            setProgress(s_progress);
        }
        else {
            setStatus(MediaTransferInterface::TransferFinished);
        }
    }
}

void MetacraneMediaTransfer::uploadMediaFinished(const QString &jid, const QString &msgId, const QString &remoteUrl)
{
    // TODO: Copied from mitakuuluu2
    Q_UNUSED(jid);
    Q_UNUSED(remoteUrl);
    if (msgId == _messageId) {
        setStatus(MediaTransferInterface::TransferFinished);
    }
}

void MetacraneMediaTransfer::uploadMediaStarted(const QString &jid, const QString &msgId, const QString &localUrl)
{
    // TODO: Copied from mitakuuluu2
    Q_UNUSED(jid);
    if (localUrl == m_filePath) {
        _messageId = msgId;
        setStatus(MediaTransferInterface::TransferStarted);
    }
}

void MetacraneMediaTransfer::uploadMediaFailed(const QString &jid, const QString &msgId)
{
    // TODO: Copied from mitakuuluu2
    Q_UNUSED(jid);
    if (msgId == _messageId) {
        setStatus(MediaTransferInterface::TransferInterrupted);
    }
}

void MetacraneMediaTransfer::cancel()
{
    // TODO: Copied from mitakuuluu2
    setStatus(MediaTransferInterface::TransferCanceled);
}

void MetacraneMediaTransfer::start()
{
    m_filePath = mediaItem()->value(MediaItem::Url).toString().replace("file://", "");
    qDebug()<<"MetacraneMediaTransfer::start; path:"<<m_filePath;
    if (m_iface) {
        qDebug()<<"MetacraneMediaTransfer::start: Calling sendFile";
        QStringList things = mediaItem()->value(MediaItem::Description).toString().split(",");
        QString craneName = things[0];
        int deletionTime = things[1].toInt();
        qDebug()<<"MetacraneMediaTransfer: craneName:"<<craneName<<"deletionTime:"<<deletionTime;
        // TODO: Excplicit mime type
        m_iface->call(QDBus::NoBlock, "sendFile", m_filePath, "no_name", craneName, deletionTime);
    }
}
