#ifndef METACRANEMEDIATRANSFER_H
#define METACRANEMEDIATRANSFER_H

#include <TransferEngine-qt5/mediatransferinterface.h>
#include <TransferEngine-qt5/mediaitem.h>

#include <QtDBus/QtDBus>

class MetacraneMediaTransfer : public MediaTransferInterface
{
    Q_OBJECT
public:
    MetacraneMediaTransfer(QObject * parent = 0);
    ~MetacraneMediaTransfer();

    bool	cancelEnabled() const;
    QString	displayName() const;
    bool	restartEnabled() const;
    QUrl	serviceIcon() const;

private:
    QDBusInterface *m_iface;
    QString m_filePath;
    QString _messageId; // TODO: Remove?

private slots:
    void uploadMediaProgress(const QString &jid, const QString &msgId, int percent);
    void uploadMediaFinished(const QString &jid, const QString &msgId, const QString &remoteUrl);
    void uploadMediaStarted(const QString &jid, const QString &msgId, const QString &localUrl);
    void uploadMediaFailed(const QString &jid, const QString &msgId);

public slots:
    void	cancel();
    void	start();

};

#endif // METACRANEMEDIATRANSFER_H
